#include <iostream>
#include <vector>
#include <stdio.h>
using namespace std;
int main()
{
    bool p=false;
    int n,m,q,i,j;
    cin>>n>>m;
    vector<int> x;
    vector<int> y;
    for(i=0;i<n;i++)
        x.push_back(1);
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            scanf("%d",&q);
            y.push_back(q);
            y[j]--;
        }
        if(p)
        {
            for(j=0;j<m;j++)
            {
                if(x[j]==-1||x[j]==0)
                    continue;
                if(y[j]==0)
                    y[j]=x[j];
                else
                {
                    int z=j;
                    if(x[j]%2==1)
                    {
                        while(y[z]==-1)
                            z--;
                        y[z]=x[j]/2;
                        z=j;
                        while(y[z]==-1)
                            z++;
                        y[z]=(x[j]/2)+1;
                    }
                }
            }
        }
        else
        {
            for(j=0;j<m;j++)
            {
                if(x[j]==-1||x[j]==0)
                    continue;
                if(y[j]==0)
                    y[j]=x[j];
                else
                {
                    int z=j;
                    if(x[j]%2==1)
                    {
                        while(y[z]==-1)
                            z--;
                        y[z]=x[j]/2+1;
                        z=j;
                        while(y[z]==-1)
                            z++;
                        y[z]=(x[j]/2);
                    }
                }
            }
        }
        for(j=0;j<m;j++)
            x[j]=y[j];
        p=!p;
    }
    for(i=0;i<n;i++)
        cout<<x[i];
    return 0;
}